{
    //FFSubmenu=HTML
	//FFName=Web-Galerie
	// Erzeugt aus den in der Computeransicht markierten Bilder eine Web-Galerie, und zwar im Ordner "Web-Galerie" im
	// FF-Arbeitsverzeichnis. Dies und anderes kann in den Zeilen 9 bis 32 angepasst werden.
	// von Dirk Bergmann (dibe); minimale Anpassungn von Andreas Kleingnther (praetor), 12/2010
	// Diese Variable knnen angepasst werden:
    
    // Layout:
    var title = "Demoshow fr \"db-gallery\""; // Titel der Show
    var subtitle = "Bilder von Dirk Bergmann"; // Untertitel
   	//var font = "Comic Sans MS"; // Font fr alle Texte
   	var font = "Verdana"; // Font fr alle Texte
	var fra_color = "#000066"; // Farbe der Kopfzeile und Indexleiste Hintergrund
   	var pic_color = "#000000"; // Hintergrundfarbe der vergroesserten Bilder 
   	var text_color = "#FFFFFF"; // Farbe der Texte
        
   	var smallwidth=160, smallheight=120; // die Gre fr die Indexbilder
   	var mediumwidth=720, mediumheight=540; // die Gre fr die in die Seite eingebetteten Bilder
   	var largewidth=10000, largeheight=1600; // die Gre fr die Popup-Bilder

	// Programkontrolle:  	
    var generate_pictures = "yes"; // Neue Bilder generieren? (zu Testzwecken oder Layoutnderungen)
    var resize_original = "yes"; // Originalbilder unverndert als Popup bernehmen? 
    var modify_original = "yes"; // Originalbilder verndern? (contrast, XE847, ...)

   	var copyright = "Copyright Dirk Bergmann";
    var copyright_into_exif = "yes"; // Copyright in exif daten einfgen
    var copyright_into_pic = "yes"; // Copyright in das Bild einfgen

   	var compression=75; // die JPG Komprimierung fr alle Bilder 
        
    var WebBase = FF_GetFFPathEx (1) + "\\Web-Galerie\\"; // Hier wird die neue Gallerie erzeugt
	var TplBase = FF_GetFFPathEx (2) + "\\db-gallery-tpl\\"; // Hier sind die Templates
	//var TplBase = "c:\\Users\\praetor\\Documents\\FixFoto\\Script\\db-gallery-tpl\\"; // Hier sind die Templates
   	var SmallBase = WebBase + "small\\"; // Ordernamen fr die fertigen Bilder u. HTML seiten
   	var MediumBase = WebBase + "medium\\";
   	var LargeBase = WebBase + "large\\";
   	var PageBase = WebBase + "pages\\";

   	// Hier folgen die internen Variablen:
   	var addx = 0;
   	var addy = 0;
   	var desc = "";
   	var fso, f1, f2, r, icount, iplus, iminus;
   	var ForReading = 1, ForWriting = 2;
   	var currPic, mextPic, prevPic, idxPic;
//    var Sh = new ActiveXObject("WScript.Shell");  // nur eine Hilfsvariable
   	var PicName, NextPicName, PrevPicName;
	
   	fso = new ActiveXObject("Scripting.FileSystemObject");

	total = FF_GetImageCount;
	if (0 < total) {

		// Ordner anlegen
    	if (!fso.FolderExists(WebBase))
     		fso.CreateFolder(WebBase);
    	if (!fso.FolderExists(SmallBase))
     		fso.CreateFolder(SmallBase);
    	if (!fso.FolderExists(MediumBase))
     		fso.CreateFolder(MediumBase);
    	if (!fso.FolderExists(LargeBase))
     		fso.CreateFolder(LargeBase);
    	if (!fso.FolderExists(PageBase))
     		fso.CreateFolder(PageBase);
     		
     	for(icount = 0; icount < total; icount++) {
     	
     		// aktuelles bild, nchstes Bild, vorheriges Bild ... 
        	currPic = FF_GetImageName(icount);
        	PicName = fso.GetBaseName(currPic);
        	iplus = icount + 1;
        	if (iplus == total) iplus = 0;
        	nextPic = FF_GetImageName(iplus);
        	NextPicName = fso.GetBaseName(nextPic);
        	iminus = icount - 1;
        	if (iminus < 0) iminus = total - 1;
        	prevPic = FF_GetImageName(iminus);
        	PrevPicName = fso.GetBaseName(prevPic);

         	FF_LoadImage(currPic);
         	desc = FF_GetExifTag("ImageDescription")

            
 			// Nur wenn die Bilder neu berechnet werden sollen ...
            if (generate_pictures == "yes") {

	        	idxPic  = LargeBase + PicName + ".jpg";
	        	if (resize_original == "yes") {FF_ILScale(largewidth, largeheight, 6, true)}
    	    	if (modify_original == "yes") {
					FF_Xe847(100)
	       			FF_AutoContrast()
				}
    	    	if (resize_original == "yes") {FF_Sharp(50,true,true,true)}
				if (copyright_into_exif == "yes") {
					FF_SetExifTag("Copyright1",copyright)
				}
				if (copyright_into_pic == "yes") {
					FF_DrawText(copyright,10,FF_GetImageHeight()-50,45,0,600,false,false,font,0)
					FF_DrawText(copyright,13,FF_GetImageHeight()-47,45,0,600,false,false,font,16777215)
				}
    	    	FF_SaveImage(idxPic,compression)

        		idxPic  = MediumBase + PicName + ".jpg";
        		FF_ILScale(mediumwidth, mediumheight, 6, true);
	        	FF_Sharp(80,true,true,true)
    	    	FF_SaveImage(idxPic,compression)
        		
        		idxPic  = SmallBase + PicName + ".jpg";
    	    	FF_ILScale(smallwidth, smallheight, 6, true);
	        	FF_Sharp(130,true,true,true)

				// Rahmen fr die Indexbilder berechnen und erzeugen
        		addx = 0;
        		addy = 0;
	        	if (FF_GetImageWidth() < smallwidth) {addx = (smallwidth - FF_GetImageWidth()) / 2}
    	    	if (FF_GetImageHeight() < smallheight) {addy = (smallheight - FF_GetImageHeight()) / 2}
        		FF_ExtendCanvas (10+addx,10+addx,20+addy,10+addy,102,102,102)
        		PicText = icount+1 + ") " + PicName;
	        	FF_DrawText(PicText,10,5,15,0,600,false,false,"Arial",16777215)
    	    	FF_SaveImage(idxPic,compression)
        	}

			// HTML Seiten fr die einzelnen Bilder (medium u. large)
   			ParseFile( TplBase + "PageTpl.htm", PageBase + PicName + ".htm");
   			ParseFile( TplBase + "PopTpl.htm", PageBase + "Pop" + PicName + ".htm");
   		}; // for

		// jetzt das "Drumherum" ...
       	currPic = FF_GetImageName(0);
       	PicName = fso.GetBaseName(currPic);

		// Die beiden Indexseiten anlegen
        ParseFile( TplBase + "index.htm", WebBase + "index.htm");
        ParseFile( TplBase + "index-a.htm", WebBase + "index-a.htm");
        
        // Die Kopfzeile u. die Infoseite
		ParseFile( TplBase + "top.htm", PageBase + "top.htm");
		ParseFile( TplBase + "info.htm", PageBase + "info.htm");
		
		// Die Schaltknpfe und das Bannerbild werden kopiert
     	fso.CopyFile(TplBase+"banner.jpg", PageBase); // Das Bild auf der Infoseite
     	fso.CopyFile(TplBase+"prev.gif", PageBase);
     	fso.CopyFile(TplBase+"next.gif", PageBase);
        fso.CopyFile(TplBase+"back.gif", PageBase);
     	fso.CopyFile(TplBase+"attach.gif", PageBase);
     	fso.CopyFile(TplBase+"detach.gif", PageBase);
        fso.CopyFile(TplBase+"exif.gif", PageBase);
        fso.CopyFile(TplBase+"large.gif", PageBase);
        fso.CopyFile(TplBase+"info.gif", PageBase);

	} 

	// Die Indexbilder werden eingebunden
	f1 = fso.OpenTextFile(TplBase + "ThumbsTpl.htm", ForReading)
	f2 = fso.OpenTextFile(PageBase + "thumbs.htm", ForWriting, true)
	while (!f1.AtEndOfStream)
	{
    	r = ParseIt(f1.ReadLine());
	
    	if (r.indexOf("@@idx") == 0 ) {
     		for(icount = 0; icount < FF_GetImageCount; icount++) { 
            	currPic = FF_GetImageName(icount);
            	PicName = fso.GetBaseName(currPic);
				f2.writeline("<!-- Thumbnails with hyperlinks -->");
				f2.write("<a href=" + PicName + ".htm");
				f2.write(" target=\"picture\">");
	 			f2.write("<img src=\"../small/" + PicName + ".jpg\" border=\"0\"");
				f2.write( "alt=\"" + PicName + "\"");
				f2.write("></a></a>");
                f2.write("<a name=" + PicName + ">");
				}
    	} // if
    	else
    	f2.writeline(r);
	};
	f2.Close();
	f1.Close();

	// Die Seite mit den EXIF daten wird erzeugt	
	f1 = fso.OpenTextFile(TplBase + "ThumbsExTpl.htm", ForReading)
	f2 = fso.OpenTextFile(PageBase + "thumbsex.htm", ForWriting, true)
	while (!f1.AtEndOfStream)
	{
    	r = ParseIt(f1.ReadLine());
    	if (r.indexOf("@@idx") == 0 ) {
			// create thumbnails and index entries
     		for(icount = 0; icount < FF_GetImageCount; icount++) { 
        		
            	currPic = FF_GetImageName(icount);
            	PicName = fso.GetBaseName(currPic);
            	desc = "-";
            	date = "-";
            	iso = "-";
            	flash = "-";
            	expo = "-";
            	aper = "-";
            	foc = "-";
            	make = "-";
            	model = "-";
            	if (FF_HasExif()) {
					FF_LoadExif(currPic)
		            desc = FF_GetExifTag("ImageDescription")
        		    date = FF_GetExifTag("DateTime")
            		iso = FF_GetExifTag("ISOSpeedRatings")
            		flash = FF_GetExifTag("Flash")
            		expo = FF_GetExifTagAdvanced("ExposureTime")
            		aper = FF_GetExifTagAdvanced("FNumber")
            		foc = FF_GetExifTagAdvanced("FocalLength")
            		make = FF_GetExifTag("Make")
            		model = FF_GetExifTag("Model")
            	}
				f2.writeline("<!-- Thumbnails with hyperlinks -->");
				f2.write("<tr><td>");
				f2.write("<a href=" + PicName + ".htm");
				f2.write(" target=\"picture\">");
	 			f2.write("<img src=\"../small/" + PicName + ".jpg\" border=\"0\" ");
				f2.write( "alt=\"" + PicName + " - " + date + "\" height=\"40\"></a></a>");
                f2.write("<a name=" + PicName + ">");
                f2.write("</td><td>");
                f2.write("<font face=\"" + font + "\">");
                f2.write(PicName);
                f2.write("</td><td>");
                f2.write("<font face=\"" + font + "\">");
                f2.write(date);
                f2.write("</td><td>");
                f2.write("<font face=\"" + font + "\">");
                f2.write(iso);
                f2.write("</td><td>");
                f2.write("<font face=\"" + font + "\">");
                f2.write(expo);
                f2.write("</td><td>");
                f2.write("<font face=\"" + font + "\">");
                f2.write(aper);
                f2.write("</td><td>");
                f2.write("<font face=\"" + font + "\">");
                f2.write(foc);
                f2.write("</td><td>");
                f2.write("<font face=\"" + font + "\">");
                f2.write(make + "/" + model);
                f2.write("</td></tr>");
				}
    	} // if
    	else
    	f2.writeline(r);
	};
	f2.Close();
	f1.Close();
	// Ende	
}

// Hilfsfunktion zum Kopieren einer Datei mit Hilfe der ...
function ParseFile( infile, outfile) {
	f1 = fso.OpenTextFile(infile, ForReading)
	f2 = fso.OpenTextFile(outfile, ForWriting, true)
	while (!f1.AtEndOfStream) {
    	f2.writeline(ParseIt(f1.ReadLine()));
	}; // while
	f2.Close();
	f1.Close();
	//return(void);
}

// ... Ersetzungsfunktion.
function ParseIt(textline){
	var re;
	re = /@@PicName/g;
	textline = textline.replace(re, PicName);
	re = /@@MaxPicName/g;
	textline = textline.replace(re, PicName);
	re = /@@font/g;
	textline = textline.replace(re, font);
	re = /@@prev/g;
	textline = textline.replace(re, PrevPicName);
	re = /@@next/g;
	textline = textline.replace(re, NextPicName);
	re = /@@desc/g;
	textline = textline.replace(re, desc);	
	re = /@@fracolor/g;
	textline = textline.replace(re, fra_color);
	re = /@@piccolor/g;
	textline = textline.replace(re, pic_color);
	re = /@@textcolor/g;
	textline = textline.replace(re, text_color);
	re = /@@title/g;
	textline = textline.replace(re, title);
	re = /@@subtitle/g;
	textline = textline.replace(re, subtitle);
	re = /@@icount/g;
	textline = textline.replace(re, icount+1);
	re = /@@total/g;
	textline = textline.replace(re, total);
	return(textline);
}

